Models/Course.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
namespace CoursesApp_Sec002.Models
{
    public class Course
    {
        [Key]
        public int Id { get; set; }
        [Required]
        [MaxLength(50)]
        public string Title { get; set; }
        [Required]
        [Range(1, 120)]
        public short Credits { get; set; }

        public ICollection<Enrollment> Enrollments { get; set; }

        public override string ToString()
        {
            return Title;
        }
    }
}

Models/Enrollment.cs
using System.ComponentModel.DataAnnotations;
using System;
namespace CoursesApp_Sec002.Models
{
    public class Enrollment
    {
        [Key]
        public int Id { get; set; }
        [Required]
        public int CourseId { get; set; }
        [Required]
        public int StudentId { get; set; }
        public Grade? Grade { get; set; }
        public DateTime EnrollmentDate { get; set; }

        public Course Course { get; set; }
        public Student Student { get; set; }
    }

    public enum Grade
    {
        A, B, C, D, E, F
    }
}

Models/ErrorViewModel.cs
using System;

namespace CoursesApp_Sec002.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Models/Student.cs
using System;
using System.ComponentModel.DataAnnotations;
using System.Collections.Generic;
using System.Collections;

namespace CoursesApp_Sec002.Models
{
    public class Student
    {
        [Key]
        public int Id { get; set; }
        [Required]
        [MaxLength(50)]
        [Display(Name = "Apellido")]
        public string LastName { get; set; }
        [Required]
        [MaxLength(50)]
        [Display(Name = "Nombre")]
        public string FirstName { get; set; }

        public DateTime? EnrollmentDate { get; set; }

        public ICollection<Enrollment> Enrollments { get; set; }

        public string FullName()
        {
            return FirstName + " " + LastName;
        }
    }
}

Models/ViewModels/EnrollmentsCreateViewModel.cs
using System.Collections.Generic;

namespace CoursesApp_Sec002.Models.ViewModels
{
    public class EnrollmentsCreateViewModel
    {
        public List<Course> Courses { get; set; }
        public Student Student { get; set; }
        public Enrollment Enrollment { get; set; }
    }
}

Controllers/EnrollmentController.cs
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

using CoursesApp_Sec002.Data;
using CoursesApp_Sec002.Models;
using CoursesApp_Sec002.Models.ViewModels;
using Microsoft.AspNetCore.Http;

namespace CoursesApp_Sec002.Controllers
{
    public class EnrollmentController : Controller
    {
        private readonly CoursesContext _context;

        public EnrollmentController(CoursesContext context)
        {
            _context = context;
        }

        public IActionResult Index()
        {
            List<Enrollment> enrollment = _context.Enrollments
                .Include(e => e.Course)
                .Include(e => e.Student).ToList();

            return View(enrollment);
        }

        public IActionResult Create(int studentId)
        {
            Student student = _context.Students.SingleOrDefault(st => st.Id == studentId);
            if(student == null)
            {
                return NotFound();
            }
            List<Course> courses = _context.Courses.ToList();

            EnrollmentsCreateViewModel model = new EnrollmentsCreateViewModel();

            model.Student = student;
            model.Courses = courses;

            return View(model);
        }

        [HttpPost]
        public IActionResult Create(IFormCollection formCollection)
        {
            if (ModelState.IsValid)
            {
                Enrollment enrollment = new Enrollment();
                enrollment.StudentId = int.Parse(formCollection["StudentId"].ToString());

                //obtengo el titulo del curso al cual se selecciono
                string courseName = formCollection["Enrollment.CourseId"].ToString();

                //busco en la base de datos el curso que se selecciono
                Course course = _context.Courses.FirstOrDefault(c => c.Title.Equals(courseName));

                enrollment.EnrollmentDate = System.DateTime.Now;

                //le asigno el id del curso al enrolamiento
                enrollment.CourseId = course.Id;

                _context.Enrollments.Add(enrollment);
                _context.SaveChanges();
            }

            return Redirect("/student/");
        }
    }
}

Controllers/HomeController.cs
using CoursesApp_Sec002.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace CoursesApp_Sec002.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Controllers/StudentController.cs
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Collections.Generic;

using CoursesApp_Sec002.Data;
using CoursesApp_Sec002.Models;
using Microsoft.EntityFrameworkCore;

namespace CoursesApp_Sec002.Controllers
{
    public class StudentController : Controller
    {
        private readonly CoursesContext _context;

        public StudentController(CoursesContext context){
            this._context = context;
        }

        public IActionResult Index()
        {
            List<Student> students = _context.Students.ToList();

            return View(students);
        }

        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(Student student)
        {
            if (ModelState.IsValid)
            {
                student.EnrollmentDate = System.DateTime.Now;
                _context.Students.Add(student);
                _context.SaveChanges();
                return RedirectToAction(nameof(Index));
            }
            return View();
        }

        public IActionResult Edit(int studentId)
        {
            Student student = _context.Students.SingleOrDefault(x => x.Id == studentId);
            if(student == null)
            {
                return NotFound();
            }

            return View(student);
        }

        [HttpPost]
        public IActionResult Edit(Student student)
        {
            if (ModelState.IsValid)
            {
                _context.Students.Update(student);
                _context.SaveChanges();
                return RedirectToAction(nameof(Index));
            }
            return View(student);
        }
    }
}

Views/Enrollment/Create.cshtml
@model CoursesApp_Sec002.Models.ViewModels.EnrollmentsCreateViewModel

<h1 class="bd-title text-center">Enrolar estudiante a curso</h1>

<div class="row align-content-center">
    <div class="offset-2 col-8 mt-2">
        <div class="card" >
            <form asp-action="Create" method="post">
                <div class="row m-5">
                    <input type="hidden" value="@Model.Student.Id" name="StudentId" />
                    <div class="col-6">
                        <label>Nombre Estudiante</label>
                        <input type="text" class="form-control" value="@Model.Student.FullName()" disabled />
                    </div>
                    <div class="col-6">
                        @Html.LabelFor(m => m.Enrollment.CourseId)
                        @Html.DropDownListFor(m => m.Enrollment.CourseId, 
                            new SelectList(Model.Courses), 
                            new { Name="CourseId", @class = "form-control" }) 

                        <!-- <select name="CourseId" required>
                            @foreach(var item in Model.Courses){
                                <option> @item.Title </option>
                            }
                        </select>-->
                    </div>
                </div>
                <div class="row m-5">
                    <div class="col-12">
                       <button type="submit" class="btn btn-primary float-right">Guardar</button>
                    </div>
                </div>
            </form>
        </div>
    </div>

</div>

Views/Enrollment/Index.cshtml
@model List<Enrollment>

<h1 class="bd-title text-center" id="content">Alumnos Enrolados</h1>

<div class="row align-content-center">
    <div class="offset-2 col-8 mt-2">
        <div class="card" >
            <table class="table table-borderless">
              <thead>
                <tr>
                  <th scope="col">Nombre Alumno</th>
                  <th scope="col">Curso</th>
                  <th scope="col">Fecha Enrolamiento</th>
                  <th scope="col">Nota</th>
                </tr>
              </thead>
              <tbody>
                @foreach (var enrollment in Model)
                {
                    <tr>
                      <td>@enrollment.Student.FullName()</td>
                      <td>@enrollment.Course.Title</td>
                      <td>@enrollment.EnrollmentDate.ToShortDateString()</td>
                      <td>@enrollment.Grade</td>
                    </tr>                   
                }
              </tbody>
            </table>
        </div>
    </div>
</div>

Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CoursesApp_Sec002</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css" integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">CoursesApp_Sec002</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Student" asp-action="Index">Estudiantes</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Enrollment" asp-action="Index">Enrolamientos</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - CoursesApp_Sec002 - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

Views/Student/Create.cshtml
@model Student
<h1 class="bd-title text-center"> Nuevo Estudiante</h1>

<div class="row align-content-center">
    <div class="offset-2 col-8 mt-2">
        <div class="card" >
            <form asp-action="Create" method="post">
                <div class="row m-5">
                    <div class="col-6">
                        @Html.LabelFor(model => model.FirstName)
                        @Html.TextBoxFor(model => model.FirstName, new { @class = "form-control" })
                        @Html.ValidationMessageFor(m => m.FirstName, "", new { @class = "text-danger" })
                    </div>
                    <div class="col-6">
                        @Html.LabelFor(model => model.LastName)
                        @Html.TextBoxFor(model => model.LastName, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.LastName, "", new { @class = "text-danger" })
                    </div>
                </div>
                <div class="row m-5">
                    <div class="col-12">
                       <button type="submit" class="btn btn-primary float-right">Guardar</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

Views/Student/Edit.cshtml
@model Student
<h1 class="bd-title text-center"> Nuevo Estudiante</h1>

<div class="row align-content-center">
    <div class="offset-2 col-8 mt-2">
        <div class="card" >
            <form asp-action="Edit" method="post">
                @Html.HiddenFor(model => model.Id)
                <div class="row m-5">
                    <div class="col-6">
                        @Html.LabelFor(model => model.FirstName)
                        @Html.TextBoxFor(model => model.FirstName, new { @class = "form-control" })
                        @Html.ValidationMessageFor(m => m.FirstName, "", new { @class = "text-danger" })
                    </div>
                    <div class="col-6">
                        @Html.LabelFor(model => model.LastName)
                        @Html.TextBoxFor(model => model.LastName, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.LastName, "", new { @class = "text-danger" })
                    </div>
                     <div class="col-6">
                        @Html.LabelFor(model => model.EnrollmentDate)
                        @Html.TextBoxFor(model => model.EnrollmentDate, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.EnrollmentDate, "", new { @class = "text-danger" })
                    </div>
                </div>
                <div class="row m-5">
                    <div class="col-12">
                       <button type="submit" class="btn btn-primary float-right">Guardar</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

Views/Student/Index.cshtml
@model List<Student> 

<h1 class="bd-title text-center" id="content">Estudiantes</h1>

<div class="row align-content-center">
    <div class="offset-2 col-8 mt-2">
        <div class="card" >
            <table class="table table-borderless">
              <thead>
                <tr>
                  <th scope="col">Nombre</th>
                  <th scope="col">Apellido</th>
                  <th scope="col">Fecha inscripción</th>
                  <th scope="col">Acciones</th>
                </tr>
              </thead>
              <tbody>
                 @foreach (var item in Model)
                 {
                    <tr>
                        <td>@item.FirstName</td>
                        <td>@item.LastName</td>
                        <td>
                            @if (item.EnrollmentDate.HasValue)
                            {
                                @item.EnrollmentDate.Value.ToShortDateString();       
                            }
                        </td>
                        <td>
                            <a class="btn btn-sm btn-outline-primary" href="/enrollment/create?studentId=@item.Id"><i class="far fa-address-book"></i></a> 
                            <a class="btn btn-sm btn-outline-primary" href="student/edit?studentId=@item.Id" ><i class="far fa-edit"></i></a> 
                        </td>
                    </tr>
                 }
              </tbody>
            </table>
        </div>
    </div>
</div>